#!/bin/sh
MYLOG=/tmp/jdinst.log
my_trace(){
        echo " case $APKG_PKG_STATUS " >> $MYLOG
}
echo "post-install" >> $MYLOG
NAME=jdownloader
PKG_PATH=/usr/local/AppCentral/${NAME}
case $APKG_PKG_STATUS in
        install)
		my_trace
	## Entware-ng is up ...
		opkg update
		opkg upgrade
		for P in bash bc coreutils coreutils-cat coreutils-ln coreutils-mkdir coreutils-tail grep sed
		do
			opkg list_installed | grep ^$P
			if [ $? -ne 0 ] ; then
				opkg install $P
			fi
		done
	;;
	uninstall)
		my_trace
        ;;
	upgrade)
		my_trace
	    if [ -e /usr/local/AppCentral/.save_jdownloader ] ; then
              if [ -e /usr/local/AppCentral/.save_jdownloader/jd ] ; then
                rm -rf ${PKG_PATH}/jd
                mv /usr/local/AppCentral/.save_jdownloader/jd ${PKG_PATH}/
		touch ${PKG_PATH}/.init_done
              fi
	      rm -rf /usr/local/AppCentral/.save_jdownloader
	    fi
        ;;
        *)
            /usr/sbin/syslog -g 0 -l 1 --user admin --event "APKG jdownloader false $APKG_PKG_STATUS status ??? "
        ;;
esac
